--- old/usr/src/man/man7d/cpuid.7d	Wed Oct  5 00:32:02 2016
+++ new/usr/src/man/man7d/cpuid.7d	Wed Oct  5 00:32:02 2016
@@ -1,5 +1,6 @@
 '\" te
 .\" Copyright (c) 2004, Sun Microsystems, Inc.  All Rights Reserved
+.\" Copyright 2015, Joyent, Inc.
 .\" The contents of this file are subject to the terms of the Common Development and Distribution License (the "License").  You may not use this file except in compliance with the License.
 .\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE or http://www.opensolaris.org/os/licensing.  See the License for the specific language governing permissions and limitations under the License.
 .\" When distributing Covered Code, include this CDDL HEADER in each file and include the License file at usr/src/OPENSOLARIS.LICENSE.  If applicable, add the following below this CDDL HEADER, with the fields enclosed by brackets "[]" replaced with your own identifying information: Portions Copyright [yyyy] [name of copyright owner]
@@ -43,6 +44,10 @@
 See the processor manufacturers documentation for further information about the
 syntax and semantics of the wide variety of information available from this
 instruction.
+.LP
+Some systems can be configured to limit the cpuid opcodes which are accessible.
+While illumos handles this condition, other software may malfunction when such
+limits are enabled.  Those settings are typically manipulated in the BIOS.
 .SH EXAMPLE
 .LP
 This example allows you to determine if the current x86 processor supports
--- /dev/null	Wed Oct  5 00:32:02 2016
+++ new/usr/src/man/man7d/zfd.7d	Wed Oct  5 00:32:02 2016
@@ -0,0 +1,81 @@
+.\"
+.\" This file and its contents are supplied under the terms of the
+.\" Common Development and Distribution License ("CDDL"), version 1.0.
+.\" You may only use this file in accordance with the terms of version
+.\" 1.0 of the CDDL.
+.\"
+.\" A full copy of the text of the CDDL should have accompanied this
+.\" source.  A copy of the CDDL is also available via the Internet at
+.\" http://www.illumos.org/license/CDDL.
+.\"
+.\"
+.\" Copyright 2015, Joyent, Inc. All rights reserved.
+.\"
+.Dd "Oct 16, 2015"
+.Dt ZFD 7D
+.Os
+.Sh NAME
+.Nm zfd
+.Nd Zone file descriptor driver
+.Sh DESCRIPTION
+The
+.Nm zfd
+character driver exports devices into the zone which can be used by a
+a standalone process within the zone as
+.Vt stdin ,
+.Vt stdout ,
+and
+.Vt stderr .
+The
+.Nm zfd
+driver behaves in a similar manner as the
+.Nm zcons(7D)
+device.
+Inside a zone, the slave side devices appear as
+.Nm /dev/zfd/[0-4] .
+.sp
+The zone's zfd device configuration is driven by
+.Nm zoneadmd
+and a zone attribute
+.Nm zlog-mode
+which is somewhat of a misnomer since its purpose has evolved. The attribute
+can have a variety of values, but the lowest two positions in the value string
+are used to control how many zfd devices are created inside the zone and if the
+primary stream is a tty.
+.sp
+.Dl --
+.Dl -n
+.Dl t-
+.Dl tn
+.sp
+With the
+.Nm t
+flag set,
+.Vt stdin ,
+.Vt stdout ,
+and
+.Vt stderr ,
+are multiplexed onto a single full-duplex stream which is configured as a tty.
+That is,
+.Nm ptem ,
+.Nm ldterm
+and
+.Nm ttycompat
+are autopushed onto the stream when the slave side is opened. There is only a
+single zfd device (0) needed for the primary stream.
+.sp
+When the
+.Nm n
+flag is set, it is assumed that output logging will be done within the zone
+itself. In this configuration 1 or 2 additional zfd devices, depending on tty
+mode
+.Nm ( t
+flag), are created within the zone. An application can then configure the
+zfd streams driver into a multiplexer. Output from the stdout/stderr zfd(s)
+will be teed into the correspond logging zfd(s) within the zone.
+.sp
+.Sh SEE ALSO
+.Xr zlogin 1 ,
+.Xr zoneadmd 1M ,
+.Xr zonecfg 1M ,
+.Xr zcons 7D
--- old/usr/src/pkg/manifests/SUNWlx.mf	Wed Oct  5 00:32:02 2016
+++ new/usr/src/pkg/manifests/SUNWlx.mf	Wed Oct  5 00:32:02 2016
@@ -20,11 +20,12 @@
 #
 
 #
-# Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
 #
 
-# Was renamed to system/zones/brand/lx, both now obsolete.
-
-set name=pkg.fmri value=pkg:/SUNWlx@0.5.11,5.11-0.143
-set name=pkg.obsolete value=true
+set name=pkg.fmri value=pkg:/SUNWlx@0.5.11,5.11-0.133
+set name=pkg.renamed value=true
 set name=variant.arch value=i386
+set name=variant.opensolaris.zone value=global value=nonglobal
+depend fmri=pkg:/system/zones/brand/lx@0.5.11,5.11-0.133 type=require
--- old/usr/src/pkg/manifests/system-header.mf	Wed Oct  5 00:32:02 2016
+++ new/usr/src/pkg/manifests/system-header.mf	Wed Oct  5 00:32:02 2016
@@ -1178,6 +1178,7 @@
 file path=usr/include/sys/ldterm.h
 file path=usr/include/sys/lgrp.h
 file path=usr/include/sys/lgrp_user.h
+file path=usr/include/sys/limits.h
 file path=usr/include/sys/link.h
 file path=usr/include/sys/list.h
 file path=usr/include/sys/list_impl.h
--- old/usr/src/pkg/manifests/system-kernel.mf	Wed Oct  5 00:32:02 2016
+++ new/usr/src/pkg/manifests/system-kernel.mf	Wed Oct  5 00:32:02 2016
@@ -236,7 +236,9 @@
 driver name=poll perms="* 0666 root sys"
 $(sparc_ONLY)driver name=power alias=ali1535d+-power
 $(i386_ONLY)driver name=power
-driver name=pseudo alias=zconsnex
+driver name=pseudo \
+    alias=zconsnex \
+    alias=zfdnex
 driver name=ptc perms="* 0666 root sys"
 driver name=ptsl perms="* 0666 root sys"
 $(sparc_ONLY)driver name=ramdisk alias=SUNW,ramdisk perms="* 0600 root sys" \
--- old/usr/src/pkg/manifests/system-test-ostest.mf	Wed Oct  5 00:32:02 2016
+++ new/usr/src/pkg/manifests/system-test-ostest.mf	Wed Oct  5 00:32:02 2016
@@ -24,6 +24,7 @@
 dir path=opt/os-tests/bin
 dir path=opt/os-tests/runfiles
 dir path=opt/os-tests/tests
+dir path=opt/os-tests/tests/file-locking
 dir path=opt/os-tests/tests/sigqueue
 file path=opt/os-tests/README mode=0444
 file path=opt/os-tests/bin/ostest mode=0555
@@ -30,6 +31,10 @@
 file path=opt/os-tests/runfiles/delphix.run mode=0444
 file path=opt/os-tests/runfiles/omnios.run mode=0444
 file path=opt/os-tests/runfiles/openindiana.run mode=0444
+file path=opt/os-tests/tests/file-locking/acquire-lock.32 mode=0555
+file path=opt/os-tests/tests/file-locking/acquire-lock.64 mode=0555
+file path=opt/os-tests/tests/file-locking/runtests.32 mode=0555
+file path=opt/os-tests/tests/file-locking/runtests.64 mode=0555
 file path=opt/os-tests/tests/poll_test mode=0555
 file path=opt/os-tests/tests/sigqueue/sigqueue_queue_size mode=0555
 file path=opt/os-tests/tests/spoof-ras mode=0555
--- old/usr/src/pkg/manifests/system-zones-brand-lx.mf	Wed Oct  5 00:32:02 2016
+++ new/usr/src/pkg/manifests/system-zones-brand-lx.mf	Wed Oct  5 00:32:03 2016
@@ -20,9 +20,133 @@
 #
 
 #
-# Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+# Copyright 2015 Joyent, Inc.
 #
 
-set name=pkg.fmri value=pkg:/system/zones/brand/lx@0.5.11,5.11-0.143
-set name=pkg.obsolete value=true
+#
+# This package will install successfully into any zone, global or
+# non-global.  The files, directories, links, and hardlinks, however,
+# will only be installed into the global zone.
+#
+<include global_zone_only_component>
+set name=pkg.fmri value=pkg:/system/zones/brand/lx@$(PKGVERS)
+set name=pkg.description value="Support for the 'lx' Brand"
+set name=pkg.summary value="lx Brand"
+set name=info.classification \
+    value="org.opensolaris.category.2008:Applications/System Utilities"
 set name=variant.arch value=i386
+dir path=etc group=sys
+dir path=etc/zones group=sys
+dir path=kernel group=sys
+dir path=kernel/fs group=sys
+dir path=kernel/fs/$(ARCH64) group=sys
+dir path=kernel/socketmod group=sys
+dir path=kernel/socketmod/$(ARCH64) group=sys
+dir path=usr group=sys
+dir path=usr/include group=bin
+dir path=usr/include/sys group=bin
+dir path=usr/kernel group=sys
+dir path=usr/kernel/brand group=sys
+dir path=usr/kernel/brand/$(ARCH64) group=sys
+dir path=usr/kernel/drv group=sys
+dir path=usr/kernel/drv/$(ARCH64) group=sys
+dir path=usr/kernel/dtrace group=sys
+dir path=usr/kernel/dtrace/$(ARCH64) group=sys
+dir path=usr/kernel/fs group=sys
+dir path=usr/kernel/fs/$(ARCH64) group=sys
+dir path=usr/kernel/strmod group=sys
+dir path=usr/kernel/strmod/$(ARCH64) group=sys
+dir path=usr/lib
+dir path=usr/lib/brand
+dir path=usr/lib/brand/lx
+dir path=usr/lib/brand/lx/$(ARCH64)
+dir path=usr/lib/brand/lx/ld
+dir path=usr/lib/brand/lx/ld/64
+dir path=usr/lib/devfsadm group=sys
+dir path=usr/lib/devfsadm/linkmod group=sys
+dir path=usr/share
+dir path=usr/share/man
+dir path=usr/share/man/man3c
+dir path=usr/share/man/man5
+dir path=usr/share/man/man7fs
+driver name=inotify perms="* 0666 root sys"
+driver name=lx_ptm perms="lx_ptmajor 0666 root sys"
+driver name=lx_systrace perms="* 0644 root sys"
+driver name=lxautofs perms="lxautofs 0600 root sys"
+file path=etc/zones/SUNWlx.xml mode=0444
+file path=etc/zones/SUNWlx26.xml mode=0444
+file path=kernel/socketmod/$(ARCH64)/lx_netlink mode=0755
+file path=kernel/socketmod/lx_netlink mode=0755
+file path=usr/kernel/brand/$(ARCH64)/lx_brand group=sys mode=0755
+file path=usr/kernel/brand/lx_brand group=sys mode=0755
+file path=usr/kernel/drv/$(ARCH64)/inotify group=sys mode=0755
+file path=usr/kernel/drv/$(ARCH64)/lx_ptm group=sys mode=0755
+file path=usr/kernel/drv/$(ARCH64)/lx_systrace group=sys mode=0755
+file path=usr/kernel/drv/$(ARCH64)/lxautofs group=sys mode=0755
+file path=usr/kernel/drv/inotify group=sys mode=0755
+file path=usr/kernel/drv/inotify.conf group=sys
+file path=usr/kernel/drv/lx_ptm group=sys
+file path=usr/kernel/drv/lx_ptm.conf group=sys
+file path=usr/kernel/drv/lx_systrace group=sys
+file path=usr/kernel/drv/lx_systrace.conf group=sys
+file path=usr/kernel/drv/lxautofs group=sys mode=0755
+file path=usr/kernel/drv/lxautofs.conf group=sys
+file path=usr/kernel/fs/$(ARCH64)/lx_cgroup group=sys mode=0755
+file path=usr/kernel/fs/$(ARCH64)/lx_devfs group=sys mode=0755
+file path=usr/kernel/fs/$(ARCH64)/lx_proc group=sys mode=0755
+file path=usr/kernel/fs/$(ARCH64)/lx_sysfs group=sys mode=0755
+file path=usr/kernel/fs/lx_cgroup group=sys mode=0755
+file path=usr/kernel/fs/lx_devfs group=sys mode=0755
+file path=usr/kernel/fs/lx_proc group=sys mode=0755
+file path=usr/kernel/fs/lx_sysfs group=sys mode=0755
+#file path=usr/kernel/strmod/$(ARCH64)/ldlinux group=sys mode=0755
+#file path=usr/kernel/strmod/ldlinux group=sys mode=0755
+file path=usr/lib/$(ARCH64)/lx_brand.so.1
+file path=usr/lib/brand/lx/$(ARCH64)/lx_librtld_db.so.1
+file path=usr/lib/brand/lx/$(ARCH64)/lx_vdso.so.1 mode=0755
+file path=usr/lib/brand/lx/config.xml mode=0444
+file path=usr/lib/brand/lx/etc_default_nfs group=sys mode=0444
+file path=usr/lib/brand/lx/ld/64/ld.config group=sys
+file path=usr/lib/brand/lx/ld/ld.config group=sys
+file path=usr/lib/brand/lx/ltp_skiplist group=sys mode=0444
+file path=usr/lib/brand/lx/ltp_tests group=sys mode=0444
+file path=usr/lib/brand/lx/lx_boot mode=0755
+file path=usr/lib/brand/lx/lx_boot_zone_busybox mode=0755
+file path=usr/lib/brand/lx/lx_boot_zone_debian mode=0755
+file path=usr/lib/brand/lx/lx_boot_zone_redhat mode=0755
+file path=usr/lib/brand/lx/lx_boot_zone_ubuntu mode=0755
+file path=usr/lib/brand/lx/lx_install mode=0755
+file path=usr/lib/brand/lx/lx_librtld_db.so.1
+file path=usr/lib/brand/lx/lx_support mode=0755
+file path=usr/lib/brand/lx/lx_vdso.so.1 mode=0755
+file path=usr/lib/brand/lx/lxinit mode=0555
+file path=usr/lib/brand/lx/platform.xml mode=0444
+file path=usr/lib/devfsadm/linkmod/SUNW_lx_link_$(ARCH).so group=sys
+file path=usr/lib/lx_brand.so.1
+file path=usr/share/man/man3c/inotify_add_watch.3c
+file path=usr/share/man/man3c/inotify_init.3c
+file path=usr/share/man/man3c/inotify_rm_watch.3c
+file path=usr/share/man/man5/inotify.5
+file path=usr/share/man/man5/lx.5
+hardlink path=usr/kernel/dtrace/$(ARCH64)/lx_systrace \
+    target=../../../kernel/drv/$(ARCH64)/lx_systrace
+hardlink path=usr/kernel/dtrace/lx_systrace \
+    target=../../kernel/drv/lx_systrace
+hardlink path=usr/kernel/fs/$(ARCH64)/lxautofs \
+    target=../../../kernel/drv/$(ARCH64)/lxautofs
+hardlink path=usr/kernel/fs/lxautofs target=../../kernel/drv/lxautofs
+legacy pkg=SUNWlxr arch=$(ARCH) category=system \
+    desc="Support for the 'lx' Brand" \
+    hotline="Please contact your local service provider" \
+    name="lx Brand (Root)" vendor="Sun Microsystems, Inc." \
+    version=11.11,REV=2009.11.11
+legacy pkg=SUNWlxu arch=$(ARCH) category=system \
+    desc="Support for the 'lx' Brand" \
+    hotline="Please contact your local service provider" \
+    name="lx Brand (Usr)" vendor="Sun Microsystems, Inc." \
+    version=11.11,REV=2009.11.11
+license cr_Sun license=cr_Sun
+license lic_CDDL license=lic_CDDL
+link path=usr/lib/brand/lx/64 target=$(ARCH64)
--- old/usr/src/pkg/manifests/system-zones.mf	Wed Oct  5 00:32:03 2016
+++ new/usr/src/pkg/manifests/system-zones.mf	Wed Oct  5 00:32:03 2016
@@ -60,6 +60,7 @@
 dir path=usr/share/man/man5
 dir path=usr/share/man/man7d
 driver name=zcons
+driver name=zfd
 file path=etc/zones/SUNWblank.xml mode=0444 variant.opensolaris.zone=global
 file path=etc/zones/SUNWdefault.xml mode=0444 variant.opensolaris.zone=global
 file path=etc/zones/index group=sys original_name=SUNWzone:etc/zones/index \
@@ -77,7 +78,9 @@
     variant.opensolaris.zone=global
 file path=usr/bin/zonestat mode=0555
 file path=usr/kernel/drv/$(ARCH64)/zcons group=sys
+file path=usr/kernel/drv/$(ARCH64)/zfd group=sys
 $(i386_ONLY)file path=usr/kernel/drv/zcons group=sys
+$(i386_ONLY)file path=usr/kernel/drv/zfd group=sys mode=0755
 file path=usr/lib/$(ARCH64)/libbrand.so.1
 file path=usr/lib/$(ARCH64)/libzonecfg.so.1
 file path=usr/lib/$(ARCH64)/libzonestat.so.1
@@ -106,6 +109,7 @@
 file path=usr/share/man/man5/brands.5
 file path=usr/share/man/man5/zones.5
 file path=usr/share/man/man7d/zcons.7d
+file path=usr/share/man/man7d/zfd.7d
 legacy pkg=SUNWzoner desc="Solaris Zones Configuration Files" \
     name="Solaris Zones (Root)"
 legacy pkg=SUNWzoneu desc="Solaris Zones Configuration and Administration" \
--- old/usr/src/test/os-tests/runfiles/omnios.run	Wed Oct  5 00:32:03 2016
+++ new/usr/src/test/os-tests/runfiles/omnios.run	Wed Oct  5 00:32:03 2016
@@ -26,3 +26,10 @@
 
 [/opt/os-tests/tests/sigqueue]
 tests = ['sigqueue_queue_size']
+
+[/opt/os-tests/tests/tmpfs]
+user = root
+tests = ['tmpfs_badmount', 'tmpfs_enospc']
+
+[/opt/os-tests/tests/file-locking]
+tests = ['runtests.32', 'runtests.64']
--- old/usr/src/test/os-tests/tests/Makefile	Wed Oct  5 00:32:03 2016
+++ new/usr/src/test/os-tests/tests/Makefile	Wed Oct  5 00:32:03 2016
@@ -13,6 +13,6 @@
 # Copyright (c) 2012 by Delphix. All rights reserved.
 #
 
-SUBDIRS = poll sigqueue spoof-ras
+SUBDIRS = poll sigqueue spoof-ras file-locking
 
 include $(SRC)/test/Makefile.com
--- /dev/null	Wed Oct  5 00:32:03 2016
+++ new/usr/src/test/os-tests/tests/file-locking/Makefile	Wed Oct  5 00:32:03 2016
@@ -0,0 +1,75 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2016 Joyent, Inc.
+#
+
+include $(SRC)/cmd/Makefile.cmd
+include $(SRC)/test/Makefile.com
+
+UTILS = util.c
+
+PROGS = \
+	runtests \
+	acquire-lock
+
+C99MODE = -xc99=%all
+
+SRCS = $(PROGS:%=%.c) $(UTILS)
+LINTS = $(SRCS:%.c=%.ln)
+PROGS32 = $(PROGS:%=%.32)
+PROGS64 = $(PROGS:%=%.64)
+
+ROOTOPTDIR = $(ROOT)/opt/os-tests/tests/file-locking
+ROOTOPTPROGS = $(PROGS32:%=$(ROOTOPTDIR)/%) \
+	$(PROGS64:%=$(ROOTOPTDIR)/%)
+
+all     :=      TARGET = all
+install :=      TARGET = install
+clean   :=      TARGET = clean
+clobber :=      TARGET = clobber
+lint    :=      TARGET = lint
+
+.KEEP_STATE:
+
+install: $(ROOTOPTPROGS)
+
+all: $(PROGS32) $(PROGS64)
+
+lint: $(LINTS)
+
+clean:
+	-rm $(PROGS32) $(PROGS64)
+
+$(ROOTOPTPROGS): $(PROGS32) $(PROGS64) $(ROOTOPTDIR)
+
+$(ROOTOPTDIR):
+	$(INS.dir)
+
+$(ROOTOPTDIR)/%: %
+	$(INS.file)
+
+$(ROOTOPTDIR)/%: %.ksh
+	$(INS.rename)
+
+%.64: %.c
+	$(LINK64.c) -o $@ $< $(UTILS) $(LDLIBS64)
+	$(POST_PROCESS)
+
+%.32: %.c
+	$(LINK.c) -o $@ $< $(UTILS) $(LDLIBS)
+	$(POST_PROCESS)
+
+clobber:
+	$(RM) $(PROGS32) $(PROGS64)
+
+FRC:
--- /dev/null	Wed Oct  5 00:32:03 2016
+++ new/usr/src/test/os-tests/tests/file-locking/acquire-lock.c	Wed Oct  5 00:32:03 2016
@@ -0,0 +1,161 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+/*
+ * Acquire the specified kind of lock with the specified parameters. After
+ * acquiring the lock, a byte will be written to stdout. The program will
+ * then wait for a byte to be written to stdin before exiting.
+ *
+ * Usage: <posix|ofd|flock> <shared|exclusive> <path>
+ */
+
+#include "util.h"
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <strings.h>
+#include <sys/file.h>
+#include <unistd.h>
+
+
+static	void	acq_fcntl(int, int, int);
+static	void	acq_flock(int fd, int mode);
+static	void	acq_run(int, lock_style_t, boolean_t);
+
+
+static void
+acq_fcntl(int fd, int cmd, int mode)
+{
+	struct flock fl;
+	int ret, i;
+
+	/*
+	 * Acquire the lock, and then try reacquiring it several times. Once we
+	 * have acquired the lock, trying to acquire it again should succeed,
+	 * and shouldn't upgrade, downgrade or free the lock.
+	 */
+	for (i = 0; i < 3; i++) {
+		flock_reinit(&fl, mode);
+		flock_log("Acquiring lock (fcntl)...\n");
+		ret = fcntl(fd, cmd, &fl);
+		if (ret == -1) {
+			err(EXIT_FAILURE, "fcntl failed");
+		}
+	}
+
+
+	/* Let the parent know we have the lock and wait */
+	flock_log("Waiting (fcntl)...\n");
+	flock_alert(1);
+	flock_block(0);
+
+	/* Now unlock */
+	flock_reinit(&fl, F_UNLCK);
+	flock_log("Releasing lock (fcntl)...\n");
+	ret = fcntl(fd, cmd, &fl);
+	if (ret == -1) {
+		err(EXIT_FAILURE, "fcntl failed");
+	}
+}
+
+
+static void
+acq_flock(int fd, int mode)
+{
+	int ret, i;
+
+	/*
+	 * Acquire the lock, and then try reacquiring it several times. Once we
+	 * have acquired the lock, trying to acquire it again should succeed,
+	 * and shouldn't upgrade, downgrade or free the lock.
+	 */
+	for (i = 0; i < 3; i++) {
+		flock_log("Acquiring lock (flock)...\n");
+		ret = flock(fd, mode);
+		if (ret == -1) {
+			err(EXIT_FAILURE, "flock failed");
+		}
+	}
+
+	/* Wait to be okayed to unlock */
+	flock_log("Waiting (flock)...\n");
+	flock_alert(1);
+	flock_block(0);
+
+	/* Release lock */
+	flock_log("Releasing lock (flock)...\n");
+	ret = flock(fd, LOCK_UN);
+	if (ret == -1) {
+		err(EXIT_FAILURE, "flock failed");
+	}
+}
+
+
+static void
+acq_run(int fd, lock_style_t style, boolean_t is_exclusive)
+{
+	switch (style) {
+	case LSTYLE_POSIX:
+		acq_fcntl(fd, F_SETLKW, is_exclusive ? F_WRLCK : F_RDLCK);
+		break;
+	case LSTYLE_OFD:
+		acq_fcntl(fd, F_OFD_SETLKW, is_exclusive ? F_WRLCK : F_RDLCK);
+		break;
+	case LSTYLE_FLOCK:
+		acq_flock(fd, is_exclusive ? LOCK_EX : LOCK_SH);
+		break;
+	default:
+		abort();
+	}
+}
+
+
+int
+main(int argc, char *argv[])
+{
+	char *modestr, *path;
+	lock_style_t style;
+	boolean_t is_exclusive;
+	int fd;
+
+	if (argc < 4) {
+		errx(EXIT_FAILURE, BAD_ARGS_MESSAGE, argc - 1);
+	}
+
+	modestr = argv[2];
+	path = argv[3];
+
+	style = flock_styleenum(argv[1]);
+
+	if (strcmp(modestr, "shared") == 0) {
+		is_exclusive = B_FALSE;
+	} else if (strcmp(modestr, "exclusive") == 0) {
+		is_exclusive = B_TRUE;
+	} else {
+		errx(EXIT_FAILURE, BAD_MODE_MESSAGE);
+	}
+
+	boolean_t rdonly = style == LSTYLE_FLOCK || !is_exclusive;
+	fd = open(path, rdonly ? O_RDONLY : O_WRONLY);
+	if (fd == -1) {
+		err(EXIT_FAILURE, "Failed to open %s", path);
+	}
+
+	acq_run(fd, style, is_exclusive);
+
+	return (0);
+}
